import requests

from types import SimpleNamespace

BASE_URL = {
    "mixtral": "https://www.google.com",
    "llama-3-8b": "https://www.google.com",
    "llama-3-70b": "https://www.google.com",
    "dummy": "https://www.google.com",
}
AUTH_TOKEN = {
    "mixtral": "Bearer OMZQQbS-bwUMSGoeW-aVFg:M-By7BK9LShn4VSIJ8QOtfzreIlx4pBfgF9tIpzGs2E",
    "llama-3-8b": "Bearer ZFcFKFeeDiK2j65n08FAiQ:DE9GW-xetGCdjJWTkWPh9r71ooX7wB5WDGXxJHseYDY",
    "llama-3-70b": "Bearer MwC2rPYXOrjGAkPmqu_VfA:KLAhjCPKx5g9VI0QXecKUIAwaIrmDb0xxB1FSd4iIQs",
    "dummy": "Bearer ZFcFKFeeDiK2j65n08FAiQ:DE9GW-xetGCdjJWTkWPh9r71ooX7wB5WDGXxJHseYD3423432",
}
MODELS = {
    "mixtral": "mistralai/Mixtral-8x7B-Instruct-v0.1",
    "llama-3-8b": "meta-llama/Meta-Llama-3-8B-Instruct",
    "llama-3-70b": "meta-llama/Meta-Llama-3.1-70B-Instruct",
    "dummy": "dummy/dummy",
}


def infer_vllm(
    prompt,
    max_tokens=2000,
    end_point="llama-3-70b",
    top_logprobs=None,
    return_full_json=False,
):
    data = {
        "model": MODELS[end_point],
        "prompt": prompt,
        "max_tokens": max_tokens,
        "temperature": 0,
        "logprobs": top_logprobs,
    }
    headers = {
        "Content-Type": "application/json",
        "Cookie": "sessiona=1687876608.234.49.972136|78cabb3f310793e5a58a141fe9058709",
        "Authorization": f"{AUTH_TOKEN[end_point]}",
    }
    try:
        result = requests.post(BASE_URL[end_point], headers=headers, json=data)
        print(result)
        result = result.json()
    except Exception as e:
        result = {
            "choices": [{"text": f"Error in generation here is the full json: {e}"}]
        }
    if return_full_json:
        return result
    try:
        return result["choices"][0]["text"]
    except KeyError as e:
        print(f"Error in making requests for {end_point}: {e}")
        print(result)
        return result["message"]
    except Exception as e:
        print(f"Error in making requests for {end_point}: {e}")
        print(result)
        return result["message"]


def main():
    prompt = "This is a sample prompt."
    result = infer_vllm(prompt, end_point="llama-3-70b")
    print(result)


if __name__ == "__main__":
    main()

    prompt = """
<|begin_of_text|><|start_header_id|>system<|end_header_id|>
{system}<|eot_id|>

<|start_header_id|>user<|end_header_id|>
{user_message}<|eot_id|>

<|start_header_id|>assistant<|end_header_id|>

"""
