from cba.utils.agent_utils import PythonREPL, pip_install, _execute_command
import numpy as np


def test_pip_install():
    stdout, valid, retry_message = pip_install("pandas")
    assert valid
    assert len(stdout) > 0
    assert len(retry_message) == 0

    stdout, valid, retry_message = pip_install("bazingaolooo")
    assert not valid
    assert len(retry_message) > 0


def test_execute_command():
    stdout, stderr, return_code = _execute_command(["echo", "cba"])
    assert stdout.strip() == "cba"
    assert return_code == 0

    stdout, stderr, return_code = _execute_command(["bazingaolooo"])
    assert return_code != 0
    assert len(stderr) > 0


def test_output_repl():
    repl = PythonREPL()
    out, valid, retry_message = repl.run("a = 1\nprint(a)")
    assert out.strip() == "1"
    assert valid
    assert len(retry_message) == 0


if __name__ == "__main__":
    test_output_repl()
    test_pip_install()
    test_execute_command()
